
#include "module.h"
#include "weapon/projectile/hornet.h"
#include "weapon_util.h"
#include "weapon_config.h"

extern int HornetPuff;
extern int HornetTrail;

#define TimeWeaponIdle		pevWeapon->fuser1
#define NextPrimaryAttack	pevWeapon->fuser2
#define NextSecondaryAttack	pevWeapon->fuser3
#define RechargeTime		pevWeapon->fuser4

RageHookReturn OnDropPlayerItem		( void*& pPlayer, char*& itemName );
RageHookReturn OnGetAmmoIndex		( char const*& ammoName, int& ret );
RageHookReturn Killed				( void *& pVictim, entvars_t*& pevAttacker, int& iGib );
RageHookReturn PreThink				( void*& pPlayer );
RageHookReturn AddPlayerItem_Pre	( void*& pPlayer, void*& pItem, int& ret );
RageHookReturn New_AddToPlayer_Post	( void*& pItem, void*& pPlayer, int& ret );
RageHookReturn Base_AddToPlayer_Post( void*& pItem, void*& pPlayer, int& ret );

#ifdef __linux__
	//void	Precache		( void* pWeapon );
	//int	GetItemInfo		( void* pWeapon, void* pItem );
	//void	FirstSpawn		( void* pWeapon );
	//int	OnDeploy		( void* pWeapon );
	//void	Holster			( void* pWeapon, int skiplocal );
	//void	Reload			( void* pWeapon );
	//void	PrimaryAttack	( void* pWeapon );
	//void	SecondaryAttack	( void* pWeapon );
	//void	WeaponIdle		( void* pWeapon );
	//void	Precache		( void* pWeapon );
	RageHookReturn	Precache		( void*& pWeapon );
	RageHookReturn	GetItemInfo		( void*& pWeapon, void*& pItem, int& ret );
	RageHookReturn	FirstSpawn		( void*& pWeapon );
	RageHookReturn	OnDeploy		( void*& pWeapon, int& ret );
	RageHookReturn	Holster			( void*& pWeapon, int& skiplocal );
	RageHookReturn	Reload			( void*& pWeapon );
	RageHookReturn	PrimaryAttack	( void*& pWeapon );
	RageHookReturn	SecondaryAttack	( void*& pWeapon );
	RageHookReturn	WeaponIdle		( void*& pWeapon );
#else
	void	_fastcall Precache			( void* arg1, DUMMY );
	int		_fastcall GetItemInfo		( void* pWeapon, DUMMY, void* pItem );
	void	_fastcall FirstSpawn		( void* pWeapon, DUMMY );
	int		_fastcall OnDeploy			( void* pWeapon, DUMMY );
	void	_fastcall Holster			( void* pWeapon, DUMMY, int skiplocal );
	void	_fastcall Reload			( void* pWeapon, DUMMY );
	void	_fastcall PrimaryAttack		( void* pWeapon, DUMMY );
	void	_fastcall SecondaryAttack	( void* pWeapon, DUMMY );
	void	_fastcall WeaponIdle		( void* pWeapon, DUMMY );
#endif
